#!/bin/sh

#Peeks a Nios register
#Usage niospeek <Nios Device Base Addr> <Register Device Register>

EXPECTED_ARGS=3

cmnd=/usr/local/bin/ppf

clearval=0
goreg=20

wrcmnd=0x10
rdcmnd=0x20

cmndreg=10
rtnreg=30

fixarglen()
{
  argfixlen=7
  argin="0000000$1"
  arglen=`expr length "$argin"`
 ##  echo "arglen: $arglen"
  argcut=$(($arglen-$argfixlen))
 ##  echo "argcut $argcut"
  fixargout=`echo -n "$argin" | cut -b $argcut-`
 ##  echo $fixargout  
}


## Call this with a hex reg address  and it reads and returns
## a hex value in 0xX format.
rfpgareg() 
{ 
 n=0
 for i in `$cmnd r $1 2 | tr '.' '\n'` ; do
   str=${str},${i}
   let n=$n+1
##  var=`echo "var${n}"`
##  echo $var is ... ${i}

   
   if [ $n -eq 7 ]; then
        regdat=`echo -n "${i}" | sed 's/\(.*\)./\1/'`
 ##     echo "RegVal $regdat"
        regdat=`echo -n "$regdat" | cut -b 3-`
 ##     echo "RegVal $regdat ClearVal $clearval"
  
   elif [ $n -eq 9 ]; then
        highregdat=`echo -n "${i}" | sed 's/\(.*\)./\1/'`
        highregdat=`echo -n "$highregdat" | cut -b 3-`
   fi 
   done
}

sendwrcmnd()
{
  fixarglen $1
  foff=$fixargout
  fixarglen $2
  freg=$fixargout
  fixarglen $3
  fdata=$fixargout

  fofflow=`echo -n $foff | cut -b 5-`
  foffhigh=`echo -n $foff | cut -b -4`

  freglow=`echo -n $freg | cut -b 5-`
  freghigh=`echo -n $freg | cut -b -4`

  fdatalow=`echo -n $fdata | cut -b 5-`
  fdatahigh=`echo -n $fdata | cut -b -4`

  ##echo "reg low $fpgareglow"
  ##echo "reg high $fpgareghigh"
  
  $cmnd w $cmndreg $wrcmnd $fofflow $foffhigh $freglow $freghigh $fdatalow $fdatahigh
  $cmnd w 20 1
  
  rfpgareg $goreg
  ##echo "readval $regdat clearval $clearval"

  while [ "$regdat" != "$clearval" ]
  do
   ##echo "readval $regdat"
   rfpgareg $goreg
  done

}


if [ $# -ne $EXPECTED_ARGS ]
then
  echo "Usage: niospeek <Nios Device Base Address> <Nios Device Register>"
  exit $E_BADARGS
fi

sendwrcmnd $1 $2 $3

echo "$readval"

